describe("Modeable", function() {

	it('in the beguining inEditMode  is false', function() {
		var modeable = new Modeable();
		expect(modeable.inEditMode()).toBe(false);
	});

	it('in the beguining inViewMode is false', function() {
		var modeable = new Modeable();
		expect(modeable.inViewMode()).toBe(false);
	});

	it('in the beguining inListMode is false', function() {
		var modeable = new Modeable();
		expect(modeable.inListMode()).toBe(false);
	});

	it('in the beguining inInlineEditMode is false', function() {
		var modeable = new Modeable();
		expect(modeable.inInlineEditMode()).toBe(false);
	});

	it('restoreDefaultMode must change the mode to list', function() {
		var modeable = new Modeable();
		modeable.restoreDefaultMode();
		expect(modeable.inListMode()).toBe(true);
	});

	it('changeMode must change the mode to any value sent by parameter', function() {
		var modeable = new Modeable();
		modeable.changeMode("anything");
		expect(modeable.getMode()).toBe("anything");
	});

	it('inEditMode must return true if the widget is in edit mode', function(){
		var modeable = new Modeable();

		modeable.changeMode('edit');
		expect(modeable.inEditMode()).toBe(true);

		modeable.changeMode('view');
		expect(modeable.inEditMode()).toBe(false);

		modeable.changeMode('list');
		expect(modeable.inEditMode()).toBe(false);

		modeable.changeMode('inline_edit');
		expect(modeable.inEditMode()).toBe(false);
	});

	it('inViewMode must return true if the widget is in view mode', function(){
		var modeable = new Modeable();
		modeable.changeMode('view');
		expect(modeable.inViewMode()).toBe(true);

		modeable.changeMode('edit');
		expect(modeable.inViewMode()).toBe(false);

		modeable.changeMode('list');
		expect(modeable.inViewMode()).toBe(false);

		modeable.changeMode('inline_edit');
		expect(modeable.inViewMode()).toBe(false);
	});

	it('inListMode must return true if the widget is in list mode', function(){
		var modeable = new Modeable();
		modeable.changeMode('list');
		expect(modeable.inListMode()).toBe(true);

		modeable.changeMode('edit');
		expect(modeable.inListMode()).toBe(false);

		modeable.changeMode('view');
		expect(modeable.inListMode()).toBe(false);

		modeable.changeMode('inline_edit');
		expect(modeable.inListMode()).toBe(false);
	});

	it('inInlineEditMode must return true if the widget is in inline_edit mode', function(){
		var modeable = new Modeable();
		modeable.changeMode('list');
		expect(modeable.inInlineEditMode()).toBe(false);

		modeable.changeMode('edit');
		expect(modeable.inInlineEditMode()).toBe(false);

		modeable.changeMode('view');
		expect(modeable.inInlineEditMode()).toBe(false);

		modeable.changeMode('inline_edit');
		expect(modeable.inInlineEditMode()).toBe(true);
	});

});