describe('zhInputPhone', function() {

	var compile;
	var scope;
	var rootScope;
	var zhInputPhone;

	beforeEach(function() {
		module('ZeedhiServices');
		module('ZeedhiFields');
		inject(function(_$compile_, $rootScope) {
			compile = _$compile_;
			rootScope = $rootScope;
			scope = $rootScope.$new();
		});
	});

	it('should type the values on field', function() {
		var field = compile('<input type="text" id="1" ng-model="valueField" data-zh-input-phone zh-input-phone></input>')(scope);
		rootScope.$digest();

		var event = angular.element.Event('keydown');
		event.key = '1';
		event.keyCode = 49;

		field.trigger(event);
		expect(field.val()).toBe('(');
	});

	it('should paste the values on field', function() {
		var field = compile('<input type="text" id="1" ng-model="valueField" data-zh-input-phone zh-input-phone></input>')(scope);
		rootScope.$digest();

		var event = angular.element.Event('paste');
		
		event.originalEvent = {
			clipboardData: {
				getData: function() {
					return '31123451234';
				}
			}
		};

		field.triggerHandler(event);

		expect(field.val()).toBe('(31) 12345-1234');
	});
});